'' =================================================================================================
''
''   File....... Cylon project.spin
''   Purpose.... 
''   Author..... Wirecutter
''   Modified from jm_Demo_Board_Cylon.spin
''   E-mail..... 
''   Started.... 
''   Updated.... 
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' 

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1     = 31
  TX1     = 30
  SDA     = 29
  SCL     = 28

  LED_MSB = 20
  LED_LSB = 27

  COL_3   = 16
  COL_0   = 19

  RCValue = 1800
con 

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control


obj

  term : "fullduplexserial"
  rc   : "RCTime3"                                                              ' get object

var

  long  wavcog
  long  stack[32]


pub main | t, idx, delay, rtime                                                 ' set method variable

  term.start(31, 30, %0000, 115200)
  pause(1)

  term.tx(CLS)
  term.str(string("By your command:", CR))
  term.str(string("RCValue=")) 
  term.dec(RCValue)
  term.str(string("     ",CR))
  
  '==={ MY CODE ]===
  rc.RCTIME_forever(5, 500, 1, @rtime)                ' start loading rtime with current RC value
  waitcnt(clkfreq / 1000 + cnt)                       ' allow a little time for rtime to get a value (may need to increase, or be able to decrease)
 
 'IF (rtime > RCValue)                                                          ' do whatever test you want here
    ' do something
  'ELSE
    ' do something else
  '===[ END MY CODE ]===
  
  term.str(string("rtime="))
  term.dec(rtime)
  term.str(string("     ",CR))
  term.str(string("rtime should equil RCValue(1800) when pot is at 5K")) 
  wavcog := cognew(playsound(10, @Cylon, 0), @stack) + 1

  delay := clkfreq / 1500 * (RCValue / 32)  ' file is 1.507 long ,, lower the 1000 for slower speed orig- 1000
  
  t := cnt
  repeat

    '===[ MY CODE ]===
    'IF (rtime > RCValue)                                                        ' do whatever test you want here
      ' do something
    'ELSE
      ' do something else
    '===[ END MY CODE ]===
  
    repeat idx from 1 to 32        ' to
      out32(idx)
      waitcnt(t += delay)

    repeat idx from 32 to 1          ' fro
      out32(idx)
      waitcnt(t += delay)

 
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


pub out32(n)

'' Enables one of 32 LEDs in matrix
'' -- output is 0 (off), 1 to 32 (led on)

  outa[LED_MSB..LED_LSB]~                                       ' clear to start
  dira[LED_MSB..LED_LSB]~~

  outa[COL_3..COL_0]~
  dira[COL_3..COL_0]~~

  if (n => 1) and (n =< 32)                                     ' if valid
    --n
    outa[LED_MSB..LED_LSB] := 1 << (n & %111)
    outa[COL_3..COL_0]     := 1 << (n >> 3)

                                                                
pri playsound(pin, pntr, count) | rate, samples, addr, t        ' call with cognew

'' Plays 8-bit, mono audio file from DAT section
'' -- pin is pin for audio (uses CTRA)
'' -- pntr is start of audio
'' -- sampletm is sample timing in cnt ticks
'' -- count is number of plays before cog unloads itself

  if (count =< 0)                                               ' if 0, play "forever"
    count := posx

  rate    := clkfreq / long[pntr + 24]                          ' get rate from header
  samples := long[pntr + 40]                                    ' get samples from header

  frqa := $80 << 24                                             ' set to "0" 
  ctra := (%00110 << 26) + pin                                  ' duty cycle mode on pin
  dira[pin] := 1                                                ' make pin an output
  
  repeat count
    t := cnt
    addr := pntr + 44                                           ' skip over wav header
    repeat samples
      frqa := byte[addr++] << 24                                ' update dac
      waitcnt(t += rate)
      
  ctra := 0
  cogstop(cogid)


pri stopsound

  if wavcog
    cogstop(wavcog~ - 1)


dat

                byte                                            ' force byte alignment
                
Cylon           file    "eye_11.wav"  
CylonEOF        byte    0                                       ' end of file

                      